# CoTan 智能科学计算笔记系统

### 什么是CoTan?
CoTan是基于python3x的一款用于数据科学等多方面的数理化系统。  
可以用于数据处理、数学运算、物理分析等场景。

### CoTan具有什么功能？
* 快速草稿版，如：快速绘制坐标系、快速标注、快速绘制函数
* 自动化网页系统，如：自动化网页测试、网络爬虫
* 可视化git控制器，快速管理git仓库
* 初等数学的代数运算，如：解线性方程、函数求解等
* 函数系统(代数模块子模块)，如：函数绘制，函数动态绘制，多函数比较等
* 数据处理，如：特征工程、数据可视化
* 机器学习，如：模型构建、模型数据可视化、特征数据可视化、矩阵运算
* 笔记本功能(社区) **部分已实现**
* 物理仿真，如：受力分析，运动分析等 **未来实现**
* 化学反应推理，如：反应计算，反应方程配平，反应机理预测 **未来实现**
* 实验室管理系统，如：人员登记、药品登记等 **未来实现**
* 数学几何分析，如：几何证明，几何约束 **未来实现**

### 为什么选择CoTan？
* 深度与Python结合，可以用Python代码以插件的形式重写方法
* 各模块为独立的进程，并且可以使用Python代码于其直接交互
* 轻便不笨重，CoTan比其他科学计算系统更轻便，下一步CoTan将会尝试把GUI移植到HTML
* 功能实用，CoTan功能丰富易用，容易上手
* CoTan将会是一个开源项目

### 如何使用CoTan？
CoTan的主程序入口时```Hello.py```，建议使用```Python3.7.5```版本运行该程序。  
你可能需要通过```pip```或其他方式安装以下模块才可以正常使用:
```
Pillow==7.0.0
pygame==1.9.6
selenium==3.141.0
requests==2.22.0
bs4==0.0.1
urllib3==1.24.3
Gitpython==3.1.0
numpy==1.18.1
pandas==0.25.3
pandas-profiling==2.5.0
scipy==1.4.1
sympy==1.5.1
matplotlib
pyecharts==1.7.0
sklearn(sciket-learn==0.22.2.post1)==0.0
pip==20.0.2
```
主页面左侧为功能按钮，目前实现的有：  
* CoTan草稿板：方便的画图系统，可以绘制函数等几何图形 
* 自动化网页：自动化网页测试、网络爬虫 
* Git仓库控制器：基于git的可视化仓库管理器，可以管理git仓库 
* 代数工厂：带数计算系统，支持符号运算，可定义未知数等求解线性方程
* 数据科学：可用于处理表格数据，如数据清洗和数据可视化
* 机器学习：提供常用机器学习算法，针对每一套算法有专门的可视化方式，并由简单的矩阵运算
* 函数实验室：多函数并列对比、求值、绘图  
* 函数工厂：针对函数测绘功能升级，针对单一函数展开研究  
* 系统管理：查询CoTan日志、安装和使用插件  
* 通信管理器：模块间通信管理、可用python直接与其交互

### CoTan的下一步计划
把CoTan的GUI重写为HTML，支持线上和本地部署，提供灵活的GUI界面

### 帮助CoTan的开发
CoTan开发团队接受并感谢：提交BUG、提交建议、提交代码、提交插件等帮助

### 关于CoTan

#### 帮助文档
* 目前，CoTan的帮助文档仍不详细，这一现状将会在以后得到改善

#### CoTan LOGO
![LOGO](http://47.91.138.150/logo.jpg)

> 坐标轴标识数学与数据，火箭代表科学和快速，两者相加构成了一副上升趋势的折线图

#### CoTan官网社区
[@CoTan官网社区](https://cotan.songzh.website/)

#### 开发人员
* [@SuperHuan](https://github.com/SuperH-0630)
* 感谢[问卷调查](https://wj.qq.com/s2/5407934/33ae)志愿者
* 感谢匿名帮助
  
#### 最后编辑时间
* 2020年3月22日 广州